#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>

#define CRC_START 'C'
#define SOH 0x01
#define STX 0x02
#define EOT 0x04
#define ACK 0x06
#define NAK 0x15
#define CAN 0x18

HANDLE file;
DWORD size;
int flag = 0;
int debug = 0;

void send_ymodem_packet( unsigned char packet_num, unsigned char* buffer );
/*------------------------------------------------------------------------------*/
/*------------------------------------------------------------------------------*/
void uart_putchar(char byte)
{
	DWORD sizeWritten2;
	DWORD event2;
	unsigned char buffer[8096];

	buffer[0] = byte;
	buffer[1] = '\0';
	WriteFile(file, buffer, 1, &sizeWritten2, 0);
	
	if (debug == 1)
		printf("Sent %x\n",buffer[0]);

	WaitCommEvent(file, &event2, 0);
}
/*------------------------------------------------------------------------------*/
unsigned char uart_getchar(int nada)
{
	DWORD sizeRead2;
	unsigned char buffer[8096];

	memset(buffer, 0, sizeof(buffer));

	ReadFile(file, buffer, 1, &sizeRead2, 0);
	
	if (debug == 1)
		printf("Got %x\n",buffer[0]);

	return(buffer[0]);
}
/*------------------------------------------------------------------------------*/
void uart_puts(unsigned char *byte)
{
	int count = 0;

	DWORD sizeWritten2;
	DWORD event2;
	int num = 0;
/*
	if (flag < 1)
	{
		sprintf( (char *)byte,"rom.bin");
		sprintf( (char *)byte + strlen("rom.bin") + 1, "%d", size);
		printf("%x %x\n",byte[128],byte[129]);
		flag++;
	}
*/
//	printf("%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",byte[0],byte[1],byte[2],byte[3],byte[4],byte[5],byte[6],byte[7],byte[8],byte[9],byte[10],byte[11],byte[12],byte[13],byte[14]);
	if (flag == 0)
	{
		WriteFile(file, byte, 130, &sizeWritten2, 0);
		WaitCommEvent(file, &event2, 0);
	}

}
/*------------------------------------------------------------------------------*/
unsigned short updcrc (unsigned char data, unsigned short crc)
{
    int i;

    crc = crc ^ ((unsigned short)data << 8);
    for (i=0; i<8; i++)
    {
        if (crc & 0x8000)
            crc = (crc << 1) ^ 0x1021;
        else
            crc <<= 1;
    }
    
    return crc;
}
/*------------------------------------------------------------------------------*/
void send_ymodem_init( unsigned char* filename )
{
	unsigned char buffer[130] = {0};
	char c;

	// Wait for "C"
	printf("Waiting for CRC_START, press space on Treo to start.\n");
	while ( 1 )	
	{
		c = uart_getchar( 0 );
		if ( c == CRC_START )
			break;
	}
	
	printf("Got CRC_START, sending block 0.\n");
//	memset( buffer, 0, sizeof(buffer));
//	memcpy( buffer, filename, strlen( filename ) );
//	send_ymodem_packet( 0, buffer );
	send_ymodem_packet( 0, filename );
}
/*------------------------------------------------------------------------------*/
void send_ymodem_done()
{
	char test = '~';
	char c;
	
	uart_putchar( EOT );

	// Wait for NACK to packet
	while ( 1 )	
	{
		c = uart_getchar( 0 );
		printf("Sent EOT, got: %x.\n",c);
		printf("Hit space on the treo and press return then on the computer...\n\n");
		
		c = ACK;

		if (( c == NAK ) || (c == ACK))
			break;
	}
	
	if (c != ACK)
	{
		uart_putchar( EOT );

		// Wait for ACK to packet
		while ( 1 )	
		{
			c = uart_getchar( 0 );
			printf("Sent second EOT, got: %x. Press enter to continue.\n",c);
			getc(stdin);
			if ( c == ACK )
				break;
		}
	}

	// NULL packet indicates end
/*	{
		unsigned char buffer2[128] = {0};
		send_ymodem_packet( 0, buffer2 );
	}
	printf("Sent NULL packet...\n");

	// CAN CAN to cancel further transmission	
	uart_putchar( CAN );
	uart_putchar( CAN ); */
}
/*------------------------------------------------------------------------------*/
void send_ymodem_packet( unsigned char packet_num, unsigned char* buffer )
{
	int i;
	int c;
	unsigned char data[130];
retry:

	uart_putchar( 1 );
	uart_putchar( packet_num );
	uart_putchar( -packet_num - 1 );
	
	{
		memset(data,0,sizeof(data));
		int crc = 0x0000;
		
		for ( i = 0; i < 128; i++ )
		{
			crc = updcrc( buffer[ i ], crc );
			data[i] = buffer[i];
		}
		
		data[128] = crc >> 8;
		data[129] = crc & 0xff;

		uart_puts(data);
	}
	
	while ( 1 )	
	{
		c = uart_getchar( 0 );
		if ( c == ACK )
			break;
			
		if ( c == NAK )
		{
			printf("NAK ");
			goto retry;
		}
	}
}
/*------------------------------------------------------------------------------*/
unsigned char smart_uart_getchar()
{
	unsigned char c;
	
	while ( 1 )
	{
		c = uart_getchar( 0 );
		if ( c != -1 )
			return ( unsigned char )c;
	}	
}
/*------------------------------------------------------------------------------*/
int receive_ymodem_packet( unsigned char* buffer, int* packet_num )
{
	unsigned char c;
	unsigned char data[130];
	int i, length;
	int crc;
	unsigned short sent_crc;
	int last_was_can = 0;
	int this_packet_num;
	int next_packet_num = ( *packet_num + 1 ) & 0xff;
	DWORD sizeRead;

retry:

	//debug = 1;
	while ( 1 )
	{	
		c = uart_getchar( 0 );
		if ( c == SOH )
		{
			length = 128;
			break;
		}
		else if ( c == STX )
		{
			length = 1024;		
			break;
		}
		else if ( c == CAN )
		{
			if ( last_was_can )
				return -1;
				
			last_was_can = 1;
		}
		else if ( c == EOT )
		{	
			uart_putchar( ACK );
			uart_putchar( CRC_START );
			uart_putchar( ACK );
			
			return -1;
		}
	}

	// packet_num and -packet_num-1
	this_packet_num = smart_uart_getchar();
	smart_uart_getchar();

	memset(data,0,sizeof(data));
	ReadFile(file, data, 128, &sizeRead, 0);
	if (sizeRead != 128)
		printf("Not 128!\n");

	crc = 0x0000;
	for ( i = 0; i < length; i++ )
	{
		do
		{
			//c = uart_getchar( 0 );
			c = data[i];
		} 
		while ( c == -1 );
		
		crc = updcrc( c, crc );

		buffer[ i ] = c;
	}
	
	sent_crc = 0x0000;
	sent_crc = (unsigned short)smart_uart_getchar();
	sent_crc <<= 8;
	sent_crc |= (unsigned short)smart_uart_getchar();
	
	if ( crc != sent_crc || this_packet_num != next_packet_num )
	{	
		uart_putchar( NAK );
		//printf("Pck Num: %x Next: %x CRC: %x SentCRC: %x\n\n",this_packet_num,next_packet_num,crc,sent_crc);
		goto retry;
	}
	else
		uart_putchar( ACK );
		
	*packet_num = this_packet_num;
		
	return length;
}
/*------------------------------------------------------------------------------*/
int is_final_ymodem_packet( unsigned char* buffer, int buffer_length, int packet_num )
{
	int i;
	
	// Check packet number and length
	if ( packet_num != 0 || buffer_length != 128 )
		return 0;
		
	// Check for NULL buffer
	for ( i = 0; i < 128; i++ )
		if ( buffer[ i ] != 0 )
			return 0;
			
	return 1;
}
/*------------------------------------------------------------------------------*/
void start_ymodem_receive( int* file_size )
{
	unsigned char buffer[ 1024 ];
	int packet_num = -1;
	int i, length;
	
	*file_size = -1;
	
	uart_putchar( CRC_START );
	printf("Sent CRC_Start...\n");
	// Get the filename
	length = receive_ymodem_packet( buffer, &packet_num );
	printf("Got block 0...\n");
	for ( i = 0; i < length; i++ )
	{
		if ( buffer[ i ] == 0 )
		{
			if ( buffer[ i + 1 ] != 0 )
			{
				unsigned const char* file_size_text = buffer + i + 1;
				*file_size = atoi( (const char*)file_size_text );
			}
			
			break;
		}
	}

	// Send another "C" to start things going
	uart_putchar( CRC_START );
}
/*------------------------------------------------------------------------------*/
int getrom()
{
	FILE *out;
	int file_size = 0;
	int packet_num = 0;
	int length = 0;
	unsigned char buffer[2048];
	int num = 0;
	int num2 = 0;

	out = fopen("rom.bin","wb");
	if (out == NULL) 
	{
		printf("Error opening output file rom.bin!\n");
		return(0);
	}
	printf("rom.bin open for writing...\n");
	start_ymodem_receive( &file_size );
	printf("y-modem transfer block 0 received...\n");
	
	while (1) {
		length = receive_ymodem_packet( buffer, &packet_num );
		if ( length == -1 )
			break;
		if (num2 % 100 == 0)
			printf("Packet num: %d\n",num2);
		for (num=0;num<length;num++)
			fputc(buffer[num],out);
		num2++;
	}

	fclose(out);
	return (1);
}
/*------------------------------------------------------------------------------*/
int sendrom()
{
	FILE *in;
	HANDLE romi;
	DWORD num;
	char byte = '~';
	unsigned char buffer[130];
	int i = 1;
	int count = 0;
	int end = 0;
	DWORD MaxP;

	romi = CreateFile("ace-palmos.zip", GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0);

	num = GetFileSize(romi,NULL);
	size = num;
	flag = 0;
	CloseHandle(romi);

	memset(buffer,0,sizeof(buffer));
	sprintf((char *)buffer,"rom.bin");
	sprintf((char *)buffer + strlen("rom.bin") + 1, "%d", num);

	printf("Rom File Size to be sent: %d\n",num);
	MaxP = num / 128;

	send_ymodem_init(buffer);
	printf("Sent block 0...\n");

	in = fopen("ace-palmos.zip","rb");
	if (in == NULL)
	{
		return(0);
	}
	
	while (1)
	{ 
		memset(buffer,0,sizeof(buffer));
		if ((fread(buffer,1,128,in)) < 128) {
			end = 1;
		}
		send_ymodem_packet(i++,(unsigned char *)buffer);
		if (i % 100 == 0)
			printf("Sent packet %d of %d\n",i,MaxP);
		if (end == 1)
			break;
	}
	printf("Ymodem transfer complete, calling EOT.\n");
	send_ymodem_done();

	return(1);
}
/*------------------------------------------------------------------------------*/
DWORD WINAPI readthread(LPVOID lpParam)  //Why the heck can't I make this work!?!?!
{
	char buffer[1024];
	DWORD sizeRead;
	DWORD sizeWritten;
	DWORD event;

	while (1) {
//		memset(buffer,0,sizeof(buffer));
//		strcat(buffer, "");
//		WriteFile(file, buffer, strlen(buffer), &sizeWritten, 0);
//		WaitCommEvent(file, &event, 0);
		
		memset(buffer,0,sizeof(buffer));
		if (ReadFile(file, buffer, sizeof(buffer), &sizeRead, 0) || sizeRead)
			printf("%s", buffer);
	}
}
/*------------------------------------------------------------------------------*/
int main(int argc, char* argv[])
{
	DCB dcb;
	char buffer[4096];
	DWORD sizeRead;
	DWORD sizeWritten;
	DWORD event;
	DWORD dwThreadId;
	COMMTIMEOUTS timeouts;
	int i;
	int FileSelect = 0;
	FILE *in,*in2;
	int x,y;
	int sent = 1;

	printf("Treo 650 ROM Restore Tool v.1 - Shadowmite\n\n");

	file = CreateFile("\\\\.\\WCEUSBSH001", GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0);
	if (file == INVALID_HANDLE_VALUE) {
		file = CreateFile("\\\\.\\WCEUSBSH002", GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0);
		if (file == INVALID_HANDLE_VALUE) {
			file = CreateFile("\\\\.\\WCEUSBSH003", GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0);
			if (file == INVALID_HANDLE_VALUE) {
				printf("Cannot open Treo 650 device node!\n");
				exit(1);
			}
		}
	}

	memset(&timeouts, 0, sizeof(timeouts));
	timeouts.ReadIntervalTimeout = 500;
	timeouts.ReadTotalTimeoutConstant = 10;
	timeouts.ReadTotalTimeoutMultiplier = 0;
	SetCommTimeouts(file, &timeouts);

	SetCommMask(file, EV_RXCHAR | EV_TXEMPTY | EV_CTS | EV_DSR | EV_RLSD | EV_ERR);

	SetupComm(file,8192,8192);
	PurgeComm(file,PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
	GetCommState(file,&dcb);
	memset(&dcb,0,sizeof(DCB));
	dcb.DCBlength = sizeof(DCB);
	dcb.BaudRate = 115200;
	dcb.fDtrControl = DTR_CONTROL_ENABLE;
	dcb.fRtsControl = RTS_CONTROL_ENABLE;
	dcb.StopBits = ONESTOPBIT;
	dcb.ByteSize = 8;
	dcb.Parity = NOPARITY;
	SetCommState(file,&dcb);

	in = fopen("romsend.load","r");
	if (in == NULL)
	{
		printf("Please make sure romsend.load is in the directory...\n");
		exit(0);
	}
	in2 = fopen("romupload.load","r");
	if (in == NULL)
	{
		printf("Please make sure romupload.load is in the directory...\n");
		exit(0);
	}

	x = 0;
	y = 0;

//  No idea why this doesn't work for reading, if used it hangs up the connection when sending... argh...
//	CreateThread(NULL,0,readthread,NULL,0,&dwThreadId);

	for (;;) {
		if (sent == 1)
			gets(buffer);
		else if (sent == 0)
		{
			if (flag != 10)
			{
				if (FileSelect == 0)
					fgets(buffer,80,in);
				else
					fgets(buffer,80,in2);
				if ((strstr(buffer,"jump") != NULL))
				{
					sent = 1;
				}
			}
			else 
			{

			}
		}

		strcat(buffer, "\r\n");

		if (strncmp(buffer, "quit", strlen("quit")) == 0)
			break;
		if (strncmp(buffer, "help", strlen("help")) == 0)
		{
			printf("\nTreo 650 Bootloader Interface Help:\n\n");
			printf("quit : Exits the program\n");
			printf("help : This help screen\n");
			printf("pullrom : Sends the rom uploader to the phone\n"); 
			printf("pushrom : Sends the rom downloader to the phone\n");
			printf("reset : Resets the communications\n");
			printf("sendrom : Y-Modem transfers ace-palmos.zip to the phone\n");
			printf("getrom : Y-Modem transfers a backup rom image from the phone\n");
			x = 1;
		}
		if (strncmp(buffer, "pullrom", strlen("pullrom")) == 0)
		{
			printf("Sending the rom uploader!\n");
			FileSelect = 0;
			sent = 0;
			x = 1;
		}
		if (strncmp(buffer, "pushrom", strlen("pushrom")) == 0)
		{
			printf("Sending the rom downloader!\n");
			FileSelect = 1;
			sent = 0;
			x = 1;
		}
		if (strncmp(buffer, "reset", strlen("reset")) == 0)
		{
			SetupComm(file,8192,2048);
			PurgeComm(file,PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
			GetCommState(file,&dcb);
			memset(&dcb,0,sizeof(DCB));
			dcb.DCBlength = sizeof(DCB);
			dcb.BaudRate = 115200;
			dcb.fDtrControl = DTR_CONTROL_DISABLE;
			dcb.fRtsControl = RTS_CONTROL_DISABLE;
			dcb.StopBits = ONESTOPBIT;
			dcb.ByteSize = 8;
			dcb.Parity = NOPARITY;
			dcb.fOutxCtsFlow = FALSE;
			dcb.fOutxDsrFlow = FALSE;
			
			SetCommState(file,&dcb);
			x = 1;
			printf("\nUSB Port reset sent...\n");
		}
		if (strncmp(buffer, "sendrom", strlen("sendrom")) == 0)
		{
			sendrom();
			x = 1;
		}
		if (strncmp(buffer, "getrom", strlen("getrom")) == 0)
		{
			getrom();
			x = 1;
		}
		if (strncmp(buffer, "always", strlen("always")) == 0)
		{
			x = 1;
			flag = 10;
			sent = 0;
		}
		if ((x != 1) && (buffer[0] != '\r')) 
		{
			WriteFile(file, buffer, strlen(buffer), &sizeWritten, 0);
			WaitCommEvent(file, &event, 0);
		}

		i = 0;
		x = 0;
  // Comment out this section if trying the read thread
		for (;;) {
			memset(buffer, 0, sizeof(buffer));
			if (!ReadFile(file, buffer + i, sizeof(buffer), &sizeRead, 0) || !sizeRead) {
				break;
			}
			else {
				printf("%s", buffer);
			}
		}
  // End the section to comment
	}

	fclose(in);
	fclose(in2);
	CloseHandle(file);
	return(1);
}

